package com.sun.jndi.cosnaming;

import java.net.MalformedURLException;
import com.sun.jndi.toolkit.url.UrlUtil;
import javax.naming.NamingException;
import javax.naming.Name;

public final class CorbanameUrl
{
    private String stringName;
    private String location;
    
    public String getStringName() {
        return this.stringName;
    }
    
    public Name getCosName() throws NamingException {
        return CNCtx.parser.parse(this.stringName);
    }
    
    public String getLocation() {
        return "corbaloc:" + this.location;
    }
    
    public CorbanameUrl(String str) throws MalformedURLException {
        if (!str.startsWith("corbaname:")) {
            throw new MalformedURLException("Invalid corbaname URL: " + str);
        }
        int n = 10;
        int endIndex = str.indexOf(35, n);
        if (endIndex < 0) {
            endIndex = str.length();
            this.stringName = "";
        }
        else {
            this.stringName = UrlUtil.decode(str.substring(endIndex + 1));
        }
        this.location = str.substring(n, endIndex);
        int index = this.location.indexOf("/");
        if (index >= 0) {
            if (index == this.location.length() - 1) {
                this.location += "NameService";
            }
        }
        else {
            this.location += "/NameService";
        }
        return;
    }
}
